## Abstraktni trida obsahujici spolecne dekoratory pro SignCell a OsmSignCell

class CommonSignCell < Cell::ViewModel
  property :km
  property :guidepost
  
  include PresentationHelper

  def show; link_to common_sign end
  
  # hezky zformátovaná kilometráž
  def km_as_length  
    km.nil? ? 'N/A' : Map.km_to_length_s(km)
  end
    
  # název rozcestníku s ikonami tras
  def guidepost_with_trails_icons
    "#{guidepost_nazev_link} #{guidepost_trails_icons}"
  end
  
  def guidepost_guidepost_link
    link_to(common_guidepost.guidepost, common_guidepost.guidepost)
  end
    
  
  
  
  # atributy do tabulky napr u guidepost#show
  def attribute_trail
    @label1 = common_sign.km.nil? ? 'NA TRASE ' : "NA #{Map.km_to_length_s(common_sign.km)} TRASY "
    @label1 += "[ #{ link_to 'přečti', edit_sign_path(common_sign)} ]"
    @value1 = link_to("#{common_trail.icon_img_html} #{common_trail.kctref}".html_safe, common_trail)
    
    if common_trail.kct_trail.nil? or common_guidepost.kct_guidepost.nil? or common_sign.kct_sign.nil?
      @label2 = 'NA TRASE KČT'
    else
      @label2 = "NA #{Map.km_to_length_s(common_sign.kct_sign.km)} TRASY KČT"
    end
    @value2 = @kct_trail.nil? ? 'N/A' : link_to(@kct_trail.html_icon_kctref, @kct_trail)

    if common_guidepost.class == Guidepost    
      @value3 =  link_to("#{common_trail.osm_trail.andand.icon_img_html} #{common_trail.osm_trail.andand.kctref}".html_safe, common_trail.osm_trail)
    else
      @value3 = 'N/A'
    end
    
    @kct_trail = common_trail.kct_trail
    render
  end
  
  # delegovani na guidepost (presneji na common_guidepost_view)
  def guidepost_kctref;             common_guidepost_view.kctref; end
  def guidepost_kctref_link;        common_guidepost_view.kctref_link; end       # KČTref s linkem vedoucím na guidepost
  def guidepost_nazev_link;         common_guidepost_view.nazev_or_na_link; end
  def guidepost_nazev_kctref_link;  common_guidepost_view.nazev_kctref_link; end
  def guidepost_trails_icons;       common_guidepost_view.trails_icons_links(skip_trails: [common_trail]); end  # ikony dalšíchch tras v rozcestníku

  # meta-metody
  
  ## pole html tabulky (td) obsahující cell_name. Viz např view/trails/_edit_with_osm_table_line.html.erb
  def td(cell_name)
    render( locals: {cell_name: cell_name}).html_safe
  end
  
  private
  alias :common_sign :model
  def common_trail;          raise NotImplementedError, 'Redefine this in children' end
  def common_guidepost;      raise NotImplementedError, 'Redefine this in children' end
  def common_guidepost_view; raise NotImplementedError, 'Redefine this in children' end
    
  def label_and_value  
  
  end
  
end
